/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.EnumAlamat;
import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.AlamatDao;
import com.portofolio.dao.PegawaiDao;
import com.portofolio.dto.PegawaiDto;
import com.portofolio.entity.Alamat;
import com.portofolio.entity.Pegawai;
import com.portofolio.entity.vo.AlamatId;
import com.portofolio.entity.vo.PegawaiId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;
import com.portofolio.util.DateUtil;


@Lazy
@Service
public class PegawaiService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private PegawaiDao pegawaiDao;
	
	@Lazy
	@Autowired
	private AlamatDao alamatDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(PegawaiDto pegawaiDto) {
		result.clear();
		Integer kdStatusPegawaiAktif = Integer.parseInt(getSettingDataFixed("kdStatusPegawaiAktif").getNilaiField());
		PegawaiId id = new PegawaiId();
		String kdPegawai =getIdTerahir(Pegawai.class.getSimpleName(), 5);
		id.setKdPegawai(kdPegawai);
		id.setKdProfile(getKdProfile());
		Pegawai pegawai = CommonUtil.findOne(pegawaiDao, id);
		if (CommonUtil.isNullOrEmpty(pegawai)) {
			pegawai = new Pegawai();
			BeanUtils.copyProperties(pegawaiDto, pegawai);
			pegawai.setNoRec(generateUuid32());
			pegawai.setVersion(1);
			pegawai.setId(id);
			pegawai.setKdStatusPegawai(kdStatusPegawaiAktif);
			pegawai.setTglDaftar(DateUtil.dateNow());
			pegawai = pegawaiDao.save(pegawai);
			
			AlamatId alamatiId = new AlamatId();
			alamatiId.setKdAlamat(getIdTerahir(Alamat.class.getSimpleName()));
			alamatiId.setKdProfile(getKdProfile());
			Alamat alamat = new Alamat();
			
			
			BeanUtils.copyProperties(pegawaiDto.getAlamat(), alamat);
			alamat.setStatusEnabled(true);
			alamat.setNoRec(generateUuid32());
			alamat.setVersion(1);
			alamat.setId(alamatiId);
			alamat.setIsBillingAddress(1);
			alamat.setEnumAlamat(EnumAlamat.PEGAWAI.getName());
			alamat.setKdPegawai(kdPegawai);
			alamat.setIsPrimaryAddress(1);
			alamat.setIsShippingAddress(1);
			alamat = alamatDao.save(alamat);
			result.put("alamat", alamat);
			result.put("pegawai", pegawai);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("pegawai.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(PegawaiDto pegawaiDto, String kdPegawai, Integer version) {
		result.clear();
		PegawaiId id = new PegawaiId();
		id.setKdPegawai(kdPegawai);
		id.setKdProfile(getKdProfile());
		Pegawai pegawai = CommonUtil.findOne(pegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(pegawai)) {
			if (version < pegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(pegawaiDto, pegawai);
			pegawai.setVersion(version);
			pegawai = pegawaiDao.save(pegawai);
			result.put("pegawai", pegawai);
			
			List<Alamat> alamatPegawai=alamatDao.findByKdPegawai(getKdProfile(), kdPegawai);
			result.put("alamat", null);
			if(CommonUtil.isNotNullOrEmpty(alamatPegawai)) {
				Alamat alamat=alamatPegawai.get(0);
				alamat.setEnumAlamat(EnumAlamat.PEGAWAI.getName());
				BeanUtils.copyProperties(pegawaiDto.getAlamat(), alamat);
				alamatDao.save(alamat);
				result.put("alamat", alamat);
			}
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaPegawai,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		Integer kdStatusPegawaiAktif = Integer.parseInt(getSettingDataFixed("kdStatusPegawaiAktif").getNilaiField());
		if (CommonUtil.isNullOrEmpty(namaPegawai)) {
			pageRes = pegawaiDao.findAllListPegawaiUser(getKdProfile(), kdStatusPegawaiAktif, statusEnabled, pageReq);
		} else {
			pageRes = pegawaiDao.findAllListPegawaiUser(getKdProfile(), kdStatusPegawaiAktif, namaPegawai, statusEnabled, pageReq);
		}
		List<Map<String,Object>> tmpPegawai=new ArrayList<Map<String,Object>>();
		for(Map<String,Object> objPegawai:pageRes) {
			objPegawai.put("alamat", null);
			String kdPegawai=objPegawai.get("kdPegawai").toString();
			List<Map<String,Object>> listAlamat=alamatDao.findByKdPegawai(getKdProfile(), kdPegawai, CONSTANT_STATUS_ENABLED_TRUE);
			if(CommonUtil.isNotNullOrEmpty(listAlamat)) {
				objPegawai.put("alamat", listAlamat.get(0));
			}
			
			tmpPegawai.add(objPegawai);
		}
		result.put("pegawai", tmpPegawai);
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdPegawai(String kdPegawai) {
		result.clear();
		result.put("alamat", null);
		result.put("pegawai", pegawaiDao.findByKdPegawai(getKdProfile(), kdPegawai, CONSTANT_STATUS_ENABLED_TRUE));
		List<Map<String,Object>> listAlamat=alamatDao.findByKdPegawai(getKdProfile(), kdPegawai, CONSTANT_STATUS_ENABLED_TRUE);
		if(CommonUtil.isNotNullOrEmpty(listAlamat)) {
			result.put("alamat", listAlamat.get(0));
		}
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(String kdPegawai, Integer version) {
		result.clear();
		PegawaiId id = new PegawaiId();
		id.setKdPegawai(kdPegawai);
		id.setKdProfile(getKdProfile());
		Pegawai pegawai = CommonUtil.findOne(pegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(pegawai)) {
			if (version < pegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			pegawai.setStatusEnabled(false);
			pegawai.setVersion(version);
			pegawai = pegawaiDao.save(pegawai);
			result.put("pegawai", pegawai);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
